/*  параметры определены в http://go/pages/gomeostaz.php
Жизненные параметры гомеостаза и Базовые стили поведения (базовые контексты рефлексов)

1 - энергия 2 - стресс 3 - гон 4-потребность в общении 5-потребность в обучении
6- Поиск, 7- жадность
файл сохранения состояния параметров: files/GomeostazParams.txt
 */
package gomeostas

//import word_sensor "BOT/brain/words_sensor"

import (
	"BOT/lib"
	"fmt"
	"os"
	"strconv"
	"strings"
)

// Текущие значения параметров гомеостаза заполняется из файла files/GomeostazParams.txt
var GomeostazParams =make(map[int]float64)
// старые значения, обновляемые при ухудшении ??????
var oldGomeostazParams=make(map[int]float64)

// скорость изменения параметров со временем
var GomeostazParamsSpeed =make(map[int]int)

// веса значимости для GomeostazSensor От 0 до 100 %
var GomeostazParamsWeight =make(map[int]int)

func init(){
	path:=lib.GetMainPathExeFile()
	lines,_:=lib.ReadLines(path+"/memory_reflex/GomeostazParams.txt")
	if len(lines)<7{// испорчен файл, восстановить
		var def="1|50\n2|0\n3|0\n4|0\n5|0\n6|0\n7|0"
		lib.WriteFileContent(lib.GetMainPathExeFile()+"/memory_reflex/GomeostazParams.txt",def)
		lines,_=lib.ReadLines(path+"/memory_reflex/GomeostazParams.txt")
	}

	for i := 0; i < len(lines); i++ {
		p:=strings.Split(lines[i], "|")
		id,_:=strconv.Atoi(p[0])
		val,_:=strconv.ParseFloat(p[1], 32)
		GomeostazParams[id]=val
		oldGomeostazParams[id]=val
	}


	lines,_=lib.ReadLines(path+"/memory_reflex/GomeostasWeight.txt")
	for i := 0; i < len(lines); i++ {
		p:=strings.Split(lines[i], "|")
		id,_:=strconv.Atoi(p[0])
		weight,_:=strconv.Atoi(p[1])
		speed,_:=strconv.Atoi(p[2])
		GomeostazParamsWeight[id]=weight
		GomeostazParamsSpeed[id]=speed
	}

	initBadDetector()
	initContextDetector()
return
}
/* приравнять oldGomeostazParams GomeostazParams
При каждом сравнении старого с новым приравнивать Для определения вектора изменения с каждым пульсом
 */
func copyToOldPsrams(){
	for id, _ := range GomeostazParams {
		oldGomeostazParams[id]=GomeostazParams[id]
	}
}
//////////////////////////////////////////////////////////






/////////////////////////////////////////////
/* ПУЛЬС ГОМЕОСТАЗА - обработка раз в секунду

 */
var GomeoPulsCount=0 // передача тика Пульса из puls.go
// коррекция текущего состояния гомеостаза и базового контекста с каждым пульсом
func GomeostazPuls(puls int){
	GomeoPulsCount=puls // передача номера тика из более низкоуровневого пакета

	gomeostazUpdate()
	baseContextUpdate()
	badDetecting()

	//При каждом сравнении старого с новым приравнивать Для определения вектора изменения с каждым пульсом
	copyToOldPsrams()
}
//////////////////////////////////////////////////////////////








/////////////////////////////////////////////////////////////////////////////
////// выдать текущие значения жизненных параметров
func GetCurGomeoParams() (string) {
	var out="";
	for id, v := range GomeostazParams {
		out+=strconv.Itoa(int(id))+";"+strconv.Itoa(int(v))+"|";
	}
	return out
}
// установка параметров гомеостаза с Пульта:
func SetCurGomeoParams(parID int,parVal string){

	GomeostazParams[parID],_=strconv.ParseFloat(parVal, 64);
	SaveCurrentGomeoParams()

/*определить базовые контексты при новых пераметрах гомеостаза baseContextUpdate()
потом 	очистить сенсоры слов и стек слов и переактивировать Дерево понимания
 */
	baseContextUpdate()

	//fmt.Println("SET: ", p0Arr[0], p0Arr[1])
	return
}
////////////////////////////////////////////////////////////////////////////////

var IsLevelBeginParam3=false // true - уровень развития для Гона достигнут
var IsLevelBeginParam5=false  // true - уровень развития для Потребность в обучении достигнут

// состояние гомеостаза
func gomeostazUpdate() {
	// изменение со временем
	changingParVal(1)
	changingParVal(2)
// Гон начинает изменяться с некоторого уровня развития Бота
if IsLevelBeginParam3 {
		changingParVal(3)
}
	changingParVal(4)
	// 	Потребность в обучении начинает изменяться с некоторого уровня развития Бота
	if IsLevelBeginParam5 {
		changingParVal(5)
	}
	changingParVal(6)
	changingParVal(7)

	// изменение по обстоятельствам
	if GomeostazParams[1]<20 {// жадность зависит от низкой энергии + стресс
		GomeostazParams[7] = ((20-GomeostazParams[1])*2.5 + (GomeostazParams[2])/2)
	}

	if GomeoPulsCount>1 && GomeoPulsCount%10 == 0 { // записать в файл текущее состояние гомеостаза раз в 10 сек
		SaveCurrentGomeoParams()
	}
	baseContextUpdate()
}
func SaveCurrentGomeoParams(){
	if len(GomeostazParams)<7{
		return
	}
	var fStr=
		"1|"+strconv.Itoa(int(GomeostazParams[1]))+"\n" +
			"2|"+strconv.Itoa(int(GomeostazParams[2]))+"\n" +
			"3|"+strconv.Itoa(int(GomeostazParams[3]))+"\n" +
			"4|"+strconv.Itoa(int(GomeostazParams[4]))+"\n" +
			"5|"+strconv.Itoa(int(GomeostazParams[5]))+"\n" +
			"6|"+strconv.Itoa(int(GomeostazParams[6]))+"\n" +
			"7|"+strconv.Itoa(int(GomeostazParams[7]))

	file, err := os.Create(lib.MainPathExeFile+"/memory_reflex/GomeostazParams.txt")
	if err != nil{
		fmt.Println("Unable to create file:", err)
		os.Exit(1)
	}
	defer file.Close()
	file.WriteString(fStr)
}
// шаг изменения парамктра со скоростью GomeostazParamsSpeed
func changingParVal(id int){
	step:=(float64(GomeostazParamsSpeed[id])/3600)
	if(id==1){
		if GomeostazParams[id]>0{
			GomeostazParams[id]+=-step
		}
		if GomeostazParams[id]<0{
			GomeostazParams[id]=0
		}
	}else
	if GomeostazParams[id]<100{
		GomeostazParams[id]+=step
	}
	if GomeostazParams[id]>100{
		GomeostazParams[id]=100
	}
}
///////////////////////////////////////////////



