/* сенсор символов, слов и фраз


 */
package word_sensor

import (
	"BOT/lib"
	"regexp"
	"strconv"
	"strings"
)

//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////

// вспомогательный шаблон воспринятых слов с числом повторений восприятия
var tempArr=make(map[string]int)


/////////////////////////////////////////
func init(){
	// залить сохранненный tempArr
	loadTempArr()
	afterLoadTempArr()
}
//////////////////////////////////////////

func SaveTempArr(){
	var out=""
	for k, v := range tempArr {
		out+=strconv.Itoa(v)+"|#|"+k+"\r\n"
	}
	lib.WriteFileContent(lib.GetMainPathExeFile()+"/memory_reflex/words_temp_arr.txt",out)
}
func loadTempArr(){
	tempArr=make(map[string]int)
	wArr,_:=lib.ReadLines(lib.GetMainPathExeFile()+"/memory_reflex/words_temp_arr.txt")
	for n := 0; n < len(wArr); n++ {
		p:=strings.Split(wArr[n], "|#|")
		v,_:=strconv.Atoi(p[0])
		tempArr[p[1]]=v
	}
}


// Новая порция текста для формирования дерева слов
//Эта функция работает как при накачке текстов,так и при вводе текста с Пульта при общении с Ботом.
func SetNewTextBlock(txt string)(string){
/*
	txt, err := url.QueryUnescape(txt)
	if err != nil {
		log.Fatal(err)
		return "ОШИБКА раскодировки"
	}
 */
	txt= strings.Replace(txt, "{#1}", "%", -1)
	//txt= strings.Replace(txt, "{#2}", "", -1)// кавычки просто очищены (пусть будет афазия :)

	var res=""
	// разделяем на фразы
	strArr:=strings.Split(txt, "|#")// а не |#| - чтобы оставлять разделитель "|"
	for i := 0; i < len(strArr); i++ {
		addNewtempArr(strArr[i]+"|")
	}

	updateWordTreeFromTempArr(4,6)

	return res
}
///////////////////////////////////////////////////
/* добавляются как целиком фраза, так и все слова во фразе
Тут же дозаполняетс дерево слов уже многократно провторяющимися элементами.

!?. в конце фразы не записывать, они распознаются отдельно
 */
func addNewtempArr(str string){
	if len(str)<2{
		return
	}
	//разделить слова
	// разбить по разделителям
	sArr:=strings.Split(str, "|")
	var wordCount=0
	// фраза без разделителей и отдельные слова (более 1 символа) - в шаблон:
	var out=""
	var isBegin=true
	cnt:=len(sArr)
	for i := 0; i < cnt; i++ {
		if len(sArr[i])==0{
			continue
		}
		//это - слово(более 1 символа), а символ
		r := []rune(sArr[i])
		if isBegin && len(r)>1{
			tempArr[sArr[i]]++
			wordCount++
		}
// во фразе оставляем и слова и символы, т.е. восстанавливаем фразу как она была
		out+=sArr[i]

		if sArr[i]==" "{
			isBegin=true
		}else{
			isBegin=false
		}


	}
	// не запоминать фразы, длинее 6 слов

	if wordCount<6 {
		tempArr[out]++
	}else{
		// разбить по знакам препинания
		zp := regexp.MustCompile(`[,:.+\(\)]`)
		sPath:=zp.Split(out, -1)
		for i := 0; i < len(sPath); i++ {
			s:=strings.Trim(sPath[i]," ")
			sSps:=strings.Split(s, " ")
			if len(sSps) > 6 {// не запоминать фразы, длинее 6 слов
				continue
			}
			r := []rune(s)
			if len(r)<2{
				continue
			}
			tempArr[s]++
		}
	}
	SaveTempArr()
	return
}
////////////////////////////////////////////////////////