package lib

import (
	"math"
	"math/rand"
	"time"
)

/* разные вспомогательные функции

 */

///////// случайное из диапазона чисел
func RandChooseDiapazonQuest(first int,last int)(int){
	rand.Seed(time.Now().UnixNano())
	n := first + rand.Intn(last-first+1)
	return n
}


// Round возвращает ближайшее целочисленное значение.
func Round(x float64) int {
	t := math.Trunc(x)
	if math.Abs(x-t) >= 0.5 {
		return int(t + math.Copysign(1, x))
	}
	return int(t)
}


///////// случайное из нескольких чисел
func RandChooseQuest(nums ... int)(int){
	var count =0
	var num[] int
	for _, n := range nums {
		num = append(num, n)
		count++
	}
	rand.Seed(time.Now().UnixNano())
	n := rand.Intn(count+1)
	return num[n]
}
////////////////////////////////////////////


///////// случайное из массива
func RandChooseIntArr(n[] int)(int){
	var count =0
	var num[] int
	for _, n := range n {
		num = append(num, n)
		count++
	}
	rand.Seed(time.Now().UnixNano())
	v := rand.Intn(count)
	return num[v]
}
////////////////////////////////////////////


// сравнение массивовв int на идентичность
func EqualArrs(a, b []int) bool {
	if len(a) != len(b) {
		return false
	}
	for i, v := range a {
		if v != b[i] {
			return false
		}
	}
	return true
}
///////////////////////////////////////////

// вернуть наиболее повторяющееся по числу значение массива и среди них первое из равных
func GetMaxCountVal(arr[]int)(int){
// группируем значения в a
	var a=make(map[int]int)
	for i := 0; i < len(arr); i++ {
	a[arr[i]]++
	}
// находим максимальное или первое из равных
	var max=0
	var ind=0
	for k, v := range a {
		if max<v{
			max=v
			ind=k
		}
	}
	return ind
}
//////////////////////////

// индекс значения в массиве
func IndexValInArr(arr[] int,val int)(bool,int){
	for k, n := range arr {
		if n==val{
			return true,k
		}
	}
	return false,0
}


// есть такое значение в массиве
func ExistsValInArr(arr[] int,val int)(bool){
	for _, n := range arr {
		if n==val{
			return true
		}
	}
	return false
}


func Abs(x int) int {
	if x < 0 {
		return -x
	}
	return x
}

func AbsFloate(x float64) float64 {
	if x < 0 {
		return -x
	}
	return x
}

func Max(x, y int) int {
	if x < y {
		return y
	}
	return x
}

func Min(x, y int) int {
	if x > y {
		return y
	}
	return x
}

// сохранить массив int в переменной
func SaveArrToVar(arr []int,to[]int)([]int){
	for a := 0; a < len(arr); a++ {
		to=append(to,arr[a])
	}
	return to
}